#!/usr/local/bin/perl -w
# CGI::OO -- Objektorientierter Stil beim CGI.pm-Modul.

use CGI;             # Modul CGI.pm aus dem CPAN

$g = new CGI;        # Erzeuge ein CGI-Objekt

# Schreibe den HTTP-Header (header()), den <TITLE> (start_html())
# sowie ein <H1>-Tag (h1())
print
    $g->header,
    $g->start_html('Willkommen'),
    $g->h1('Willkommen bei CGI.pm');

# In welchem Kontext wurden wir aufgerufen?
if (not $g->param('NAME')) {
    # Wir haben keine Daten erhalten, daher soll das
    # CGI-Formular ausgegeben werden.
    print
        $g->start_form,
        "Wie hei&szlig;en Sie? ",
        $g->textfield('-name' => 'NAME', '-size' => 60),
        $g->submit,
        $g->end_form;
} else {
    # Da wir mittels param() Daten erhalten haben,
    # muessen diese ausgewertet werden. Wir lesen sie aus
    # und senden eine Antwortseite zurueck.
    print
        "Hallo, ",
        $g->em($g->param('NAME'));
}

# Schliesslich beenden wir die HTML-Seite (</HTML>)
# und schliessen die Verbindung.
print
    $g->end_html();

exit 0;
