# ClassWithAnonHash.pm -- Objektattribute in einem anonymen Hash.
#                         Generisches Beispiel.

package ClassWithAnonHash;

sub new {
    my $classname = shift;
    my $ptr       = {};        # Anonymer Attributhash
    bless($ptr, $classname);
    $ptr->_init(@_);           # Attribute speichern
    return $ptr;
}

sub _init {
    my $obj   = shift;         # Das zu initialisierende Objekt
    my %param = @_;            # AttrX => ValX, AttrY => ValY, ...

    %{ $obj } = %param;        # 1:1-Zuweisung von Hashes
}

sub getAttributeNames {
    my $obj   = shift;         # Das betroffene Objekt
    return keys %{ $obj };     # Die Namen seiner Attribute
}

sub getAttribute {
    my $obj   = shift;         # Aus welchem Objekt?
    my $attr  = shift;         # Welches Attribut?

    return $obj->{$attr};      # Okay, das stimmt.
}

sub setAttribute {
    my $obj    = shift;        # Welches Objekt?
    my $attr   = shift;        # Welches Attribut?
    my $newval = shift;        # Neuer Wert.

    $obj->{$attr} = $newval;   # Jawohl, neuer Wert.
}

1;
