#!/usr/local/bin/perl -w
# tkcheck.pl -- demo of checkbutton widgets

use strict;
use Tk;

# declaration of the used variables
my ($mw, $c1, $c2, $c3, $c4, $c5);
my ($btnxit);
my ($now, $c1_value, $c2_value, $c_common, $c5_value);

# first of all, create a main window
$mw = MainWindow->new();

# create some checkbuttons

#### a simple checkbutton
$c1_value = "I am ready";    # predifined on
$c1 = $mw->Checkbutton(-text     => "Ready",
                       -command  => sub { print "c1: $c1_value\n" },
                       -state    => "normal",
                       -variable => \$c1_value,
                       -onvalue  => "I am ready",
                       -offvalue => "I ain't ready");

# a checkbutton with dynamic text
$now = localtime(time);
$c2 = $mw->Checkbutton(-textvariable => \$now,
                       -anchor       => "w",
                       -command      => sub { $now = localtime(time) },
                       -state        => "active",
                       -variable     => \$c2_value,
                       -onvalue      => $now,
                       -offvalue     => "No time");

#### c3 and c4 are related
$c3 = $mw->Checkbutton(-text     => "Related with next button",
                       -anchor   => "w",
                       -variable => \$c_common,
                       -onvalue  => "ON",
                       -offvalue => "OFF");
$c4 = $mw->Checkbutton(-text     => "Related with previous button",
                       -anchor   => "w",
                       -variable => \$c_common,
                       -onvalue  => "ON",
                       -offvalue => "OFF");

#### c5 is disabled
$c5 = $mw->Checkbutton(-text     => "I am disabled",
                       -anchor   => "w",
                       -state    => "disabled",
                       -command  => sub { print "never reached\n" },
                       -variable => \$c5_value);

# generate an exit-button
$btnxit = $mw->Button(-text     => "Exit",
                      -command  => sub { exit 0 });

# display everything
$c1->pack(-anchor => 'w', -fill => 'x');
$c2->pack(-anchor => 'w', -fill => 'x');
$c5->pack(-anchor => 'w', -fill => 'x');
$c3->pack(-anchor => 'w', -fill => 'x');
$c4->pack(-anchor => 'w', -fill => 'x');

$btnxit->pack(-fill => 'both', -expand => 'yes');

# enter main event collecting loop
MainLoop;
