#!/usr/local/bin/perl -w
# tkentry.pl -- demo of entry widgets

use strict;
use Tk;

# declaration of the used variables
my ($mw, $ent1, $ent2, $ent3);
my ($ent1_val, $ent2_val, $ent3_val);
my ($fup, $fdw, $f1, $f2);
my ($btnxit);

# first of all, create a main window
$mw = MainWindow->new();

# create some frames stacked on top of each other
$fup = $mw->Frame()->pack();
$fdw = $mw->Frame()->pack();
$f1  = $fup->Frame()->pack(-side => 'left');
$f2  = $fup->Frame()->pack(-side => 'left');

# create some labels to ask user something
$f1->Label(-text => "Your Name:")->pack(-padx => '1c', -anchor => 'w');
$f1->Label(-text => "Your Age:")->pack(-padx => '1c', -anchor => 'w');
$f1->Label(-text => "Summary:")->pack(-padx => '1c', -anchor => 'w');

# now, create some entry widgets
$ent1 = $f2->Entry(-textvariable => \$ent1_val)->pack();
$ent2 = $f2->Entry(-textvariable => \$ent2_val)->pack();
$ent3 = $f2->Entry(-textvariable => \$ent3_val,
                   -state        => "disabled")->pack();

# bind the <RETURN> event to the updater function
$ent1->bind('<Return>', \&update_val);
$ent2->bind('<Return>', \&update_val);

# create a label widget
# this will mirror the contents of the name
# while being edited
$fdw->Label(-textvariable => \$ent1_val)->pack(-pady => '1c');

# create a quit button
$btnxit = $fdw->Button(-text    => "Exit",
                       -command => sub { exit 0; });
$btnxit->pack(-expand => 'both', -fill => 'both');

# the main event collector loop
MainLoop;

# --- the helper sub
sub update_val {
    $ent3_val = "$ent1_val, $ent2_val years old";
}

