#!/usr/local/bin/perl -w
# tkframe.pl -- demo of the frame widgets

use strict;
use Tk;

# declaration of our variables
my ($mw);
my ($f1, $f2, $f3, $f21, $f22);
my ($lab1, $ent1, $lab2, $btn, $lab31, $lab32);
my ($ent1_val);

# first of all, create a main window
$mw = MainWindow->new();

# create three frames
$f1 = $mw->Frame(-relief      => 'ridge',
                 -width       => '10c',
                 -height      => '3c',
                 -borderwidth => '2m');

$f2 = $mw->Frame(-relief      => 'sunken',
                 -width       => '10c',
                 -borderwidth => '2m');

$f3 = $mw->Frame(-relief      => 'groove',
                 -width       => '10c',
                 -height      => '3c',
                 -borderwidth => '2m');

$f1->pack(-padx => '1c', -pady => '1c');
$f2->pack(-padx => '1c', -pady => '1c');
$f3->pack(-padx => '1c', -pady => '1c');

# fill the frame with objects
$lab1 = $f1->Label(-text         => 'Filename:');
$ent1 = $f1->Entry(-textvariable => \$ent1_val);
$lab1->pack(-side => 'left', -pady => '0.5c', -padx => '0.3c');
$ent1->pack(-side => 'right', -pady => '0.5c', -padx => '0.3c');

$lab2 = $f2->Label(-text => "This is a sunken frame");
$lab2->pack(-pady => '0.5c', -padx => '1c');

# a nested frame
$f21  = $f2->Frame(-relief      => 'raised',
                   -width       => '5c',
                   -height      => '1.5c',
                   -borderwidth => '2m');
$f21->pack(-pady => '1c', -padx => '1c');
$f21->Label(-text => 'raised')->pack();

# another nested frame
$f22  = $f2->Frame(-relief      => 'flat',
                   -width       => '5c',
                   -height      => '1.5c',
                   -borderwidth => '2m');
$f22->pack(-pady => '0.5c', -padx => '1c');
$f22->Label(-text => 'flat')->pack();

$btn  = $f2->Button(-text    => "Exit",
                    -command => sub { exit 0 });
$btn->pack(-fill => 'x', -padx => '1c', -pady => '1c');

$lab31 = $f3->Label(-text         => "Selected File:");
$lab32 = $f3->Label(-textvariable => \$ent1_val);
$lab31->pack();
$lab32->pack(-side => 'left', -padx => '1c');

# now enter main event loop
MainLoop;
