#!/usr/local/bin/perl -w
# tklistbox.pl -- demo of listbox widgets

use strict;
use Tk;

# declaration of the used variables
my ($mw, $fup, $fdw, $fl, $fr);
my ($lbs, $lbx, $lbs_val, $lbx_val);
my ($btnxit, $btnsel);
my ($file);

# first of all, create a main window
$mw = MainWindow->new();

# create some frames
$fup = $mw->Frame(-relief      => 'ridge',
                  -borderwidth => '2m')->pack(-pady => '0.5c');
$fdw = $mw->Frame(-relief => 'ridge',
                  -borderwidth => '2m')->pack(-pady => '0.5c');
$fl  = $fup->Frame()->pack(-side => 'left');
$fr  = $fup->Frame()->pack(-side => 'left');

# create a single selection listbox
$lbs = $fl->ScrlListbox(-label      => 'Single Selection',
                        -selectmode => 'single',
                        -height     => 5,
                        -exportselection => 0);
$lbs->pack(-pady => '1c', -padx => '0.5c');


# create an extended selection listbox
$lbx = $fr->ScrlListbox(-label      => 'Extended Selection',
                        -selectmode => 'extended',
                        -height     => 5,
                        -exportselection => 0);
$lbx->pack(-pady => '1c', -padx => '0.5c');

# fill in the listbox with entries
foreach $file (<*.pl>) {
    $lbs->insert(0, $file);     # insert at begin
                                # means reversed list
    $lbx->insert("end", $file); # "normal" appending
}

# the lower frame $fdw will contain some status infos,
# a query button and label
# and the exit button

# create the getselection button
$btnsel = $fdw->Button(-text    => "Read Selections",
                       -command => \&read_sel);
$btnsel->pack(-fill => 'both', -pady => '0.5c');

# create the result labels
$fdw->Label(-textvariable => \$lbs_val)->pack(-pady => '0.25c');
$fdw->Label(-textvariable => \$lbx_val)->pack(-pady => '0.25c');

# create a quit button
$btnxit = $fdw->Button(-text    => "Exit",
                       -command => sub { exit 0; });
$btnxit->pack(-fill => 'both', -pady => '0.5c');

# the main event collector loop
MainLoop;

# the helper function
sub read_sel {
    my @vals;
    $lbs_val = $lbs->Getselected();

    @vals = $lbx->Getselected();
    $lbx_val = join(',', @vals);
}
