#!/usr/local/bin/perl -w
# tkmain.pl -- using perl/tk

use strict;
use Tk;

# declaration of variables
my ($mw, $btn1, $btn2, $btn3, $btnx);
my ($entry);
my $var;

# create main window
$mw   = MainWindow->new();

# create three buttons
$btn1 = $mw->Button(-text    => "Hello World",
                    -command => \&greeting);
$btn2 = $mw->Button(-text    => "Arg 1",
                    -command => [\&btn, "A1"]);
$btn3 = $mw->Button(-text    => "Arg 2",
                    -command => [\&btn, "A2"]);
$btnx = $mw->Button(-text    => "Exit",
                    -command => sub { exit 0; });

# create a text entry widget
$entry = $mw->Entry(-textvariable => \$var);

# bind the entry Return-Event to an anonymous sub
$entry->bind('<Return>',
             sub { print "You said: $var\n"; });

# pack everything
$btn1->pack(-fill => 'x');
$btn2->pack(-fill => 'x');
$btn3->pack(-fill => 'x');
$btnx->pack(-fill => 'x');
$entry->pack(-fill => 'x', -padx => '1c', -pady => '1c');

# enter main event loop
MainLoop;

# the callbacks
sub greeting
{
    print "Hello World!\n";
}

sub btn
{
    my ($arg1) = @_;

    print "You entered: $arg1\n";
}
