#!/usr/local/bin/perl -w
# tkmenu.pl -- demo of the menu-related widgets

use strict;
use Tk;

# declaration of our variables
my ($mw);
my ($mb, $m_file, $m_edit, $m_opts, $m_help);
my ($m_help_about);
my ($o_radio, $o_check1, $o_check2);

# create a main window 
$mw = MainWindow->new();

# a menu consists of a horizontal menubar,
# with associated submenus

##### first create the horizontal menubar
$mb = $mw->Frame(-relief => 'raised', -bd => 2);

# now put in the menubar some menubuttons
$m_file = $mb->Menubutton(-text      => "File",
                          -underline => 0);
$m_edit = $mb->Menubutton(-text      => "Edit",
                          -underline => 0);
$m_opts = $mb->Menubutton(-text      => "Options",
                          -underline => 0);
$m_help = $mb->Menubutton(-text      => "Help",
                          -underline => 0);

# pack everything from the menubar
$mb->pack(-side => "top", -fill => "x");
$m_file->pack(-side => "left");
$m_edit->pack(-side => "left");
$m_opts->pack(-side => "left");
$m_help->pack(-side => "right");

#### now create the submenus

# the file menus
$m_file->command(-label => "New",
                 -command => [\&file, "new"]);
$m_file->command(-label => "Open",
                 -command => [\&file, "open"]);
$m_file->command(-label => "Save",
                 -command => [\&file, "save"], 
                 -state => "disabled");
$m_file->command(-label => "Save As",
                 -command => [\&file, "saveas"],
                 -state => "disabled");
$m_file->separator();
$m_file->command(-label => "Exit",
                 -underline => 1,
                 -command => sub { exit 0; });

# the edit submenus
$m_edit->command(-label   => "Copy",
                 -command => [\&edit, "copy"]);
$m_edit->command(-label   => "Cut",
                 -command => [\&edit, "cut"]);
$m_edit->command(-label => "Paste",
                 -command => [\&edit, "paste"]);

# the opts submenus
$m_opts->command(-label   => "Command",
                 -command => [\&opts, "command"]);
$m_opts->separator();
$m_opts->checkbutton(-label    => "Check 1",
                     -variable => \$o_check1,
                     -command  => [\&opts, "check"]);
$m_opts->checkbutton(-label    => "Check 2",
                     -variable => \$o_check2,
                     -command  => [\&opts, "check"]);
$m_opts->separator();
$m_opts->radiobutton(-label    => "Radio 1",
                     -variable => \$o_radio,
                     -value    => "r1",
                     -command  => [\&opts, "radio"]);
$m_opts->radiobutton(-label    => "Radio 2",
                     -variable => \$o_radio,
                     -value    => "r2",
                     -command  => [\&opts, "radio"]);

# the help submenus
$m_help->command(-label => "Help me",
                 -command => [\&help, "help"]);
$m_help->separator();

$m_help_about = $m_help->cget(-menu)->Menu();
$m_help->cascade(-label => "About",
                  -menu => $m_help_about);
$m_help_about->command(-label => "Perl",
                       -command => [\&about, "perl"]);
$m_help_about->command(-label => "Tk",
                       -command => [\&about, "tk"]);
$m_help_about->command(-label => "UNIX",
                       -command => [\&about, "unix"]);

##### finally, call the main event collecting loop
MainLoop;

#### the callbacks
sub file {
    my ($arg) = @_;
    print "file: $arg\n";
}

sub edit {
    my ($arg) = @_;
    print "edit: $arg\n";
}

sub opts {
    my ($arg) = @_;
    print "opts: $arg\n";
    print "    radio  : $o_radio\n";
    print "    check 1: $o_check1\n";
    print "    check 2: $o_check2\n";
}

sub help {
    my ($arg) = @_;
    print "help: $arg\n";
}

sub about {
    my ($arg) = @_;
    print "about: $arg\n";
}