#!/usr/local/bin/perl -w
# tkradio.pl -- demo of radiobutton widgets

use strict;
use Tk;

# declaration of the used variables
my ($mw);
my (%rf, %rh);
my ($btnxit);
my ($now, $r_ftp, $r_http);
my ($key);
my (%FTP_SERVERS, %HTTP_SERVERS);

# first of all, create a main window
$mw = MainWindow->new();

# create some radiobuttons

#### first group of radiobuttons on common var: $r_ftp
%FTP_SERVERS = ('Koeln'  => 'ftp://ftp.rrz.uni-koeln.de',
                'Bochum' => 'ftp://ftp.rz.ruhr-uni-bochum.de',
                'UU'     => 'ftp://ftp.uu.net',
                'MIT'    => 'ftp://ftp.mit.edu',
                'FUNET'  => 'ftp://ftp.funet.fi');

foreach $key (sort keys %FTP_SERVERS) {
    $rf{$key} = $mw->Radiobutton(-text     => $key,
                                 -anchor   => "w",
                                 -variable => \$r_ftp,
                                 -value    => $FTP_SERVERS{$key},
                                 -command  => \&ftp);

    $rf{$key}->configure(-state => "active") if ($key =~ /MIT/);
    $rf{$key}->configure(-state => "disabled") if ($key =~ /FUNET/);
    $rf{$key}->pack(-fill => 'x');
}
$r_ftp = $FTP_SERVERS{"Koeln"};   # select this value as default

#### generate an exit-button
$btnxit = $mw->Button(-text     => "Exit",
                      -command  => sub { exit 0 });
$btnxit->pack(-fill => 'both',
              -expand => 'yes',
              -pady => '1c', -padx => '1c');

#### second group of radiobuttons of common var: $r_http
%HTTP_SERVERS = ('Koeln' => 'http://www.uni-koeln.de',
                 'Perl'  => 'http://www.perl.com',
                 'Sun'   => 'http://www.sun.com');

foreach $key (sort keys %HTTP_SERVERS) {
    $rh{$key} = $mw->Radiobutton(-text     => $key,
                                 -anchor   => "w",
                                 -variable => \$r_http,
                                 -value    => $HTTP_SERVERS{$key},
                                 -command  => \&http);
    $rh{$key}->pack(-fill => 'x');
}

# enter main event collecting loop
MainLoop;

# ----- helper routines
sub ftp  { print "you choose ftp: $r_ftp\n";   }
sub http { print "you choose http: $r_http\n"; }
