#!/usr/local/bin/perl -w
# tkscale.pl -- demo of the scale widget

use strict;
use Tk;

# declaration of our variables
my ($mw, $s_red, $s_green, $s_blue);
my ($pad, $btnxit);
my ($f1, $f2);

# first, create the main window
$mw = MainWindow->new();

# now, create two frames, stacked on top of each other
$f1 = $mw->Frame()->pack();
$f2 = $mw->Frame(-relief => "ridge")->pack(-pady => "1c");

# the lower frame contains a canvas of the target color
$pad = $f2->Canvas(-background => "Black");
$pad->pack();

# the upper frame contains the 3 scales
$s_red   = $f1->Scale(-from => 0, -to => 255,
                      -orient  => "vertical",
                      -label   => "Red",
                      -command => \&redraw);
$s_green = $f1->Scale(-from => 0, -to => 255,
                      -orient  => "vertical",
                      -label   => "Green",
                      -command => \&redraw);
$s_blue  = $f1->Scale(-from => 0, -to => 255,
                      -orient  => "vertical",
                      -label   => "Blue",
                      -command => \&redraw);
$s_red->pack(-side => "left");
$s_green->pack(-side => "left");
$s_blue->pack(-side => "left");

$s_red->set(0); $s_green->set(0); $s_blue->set(0);

# create an exit button
$btnxit = $f1->Button(-text    => "Exit",
                      -command => sub { exit 0 });
$btnxit->pack(-side   => "left",
              -expand => "both",
              -fill   => "both");

# enter the main event collecting loop
MainLoop;

#### helper function
sub redraw {
    my $col;
    $col = sprintf("#%02x%02x%02x",
                   $s_red->get(),
                   $s_green->get(),
                   $s_blue->get());
    $pad->configure(-background => $col);
}



