#!/usr/local/bin/perl -w
# addcumul.pl -- wantarray() und kumulative Summe

sub addcumul {
    if (wantarray) {
        # Listenkontext: Kumulative Summe berechnen
        my @sum = @_;               # Kopie anlegen
        my $total;

        foreach $sum (@sum) { $sum = $total += $sum; }
        return @sum;
    } else {
        # Skalarer Kontext: Normale Summe berechnen
        my ($total, $sum);

        foreach $sum (@_) { $total += $sum; }
        return $total;
    }
}

# Aufruf im skalaren und im Listenkontext:
@list = 5 .. 10;            # Eingabearray

$tot  = addcumul @list;     # Skalarer Kontext
print "Total: $tot\n";

@res  = addcumul @list;     # Listenkontext
print "@res\n";             # Ergebnisliste anzeigen
