#!/usr/local/bin/perl
# apache-logs.pl -- Hits mit absteigender Haeufigkeit: Apache::ParseLogs

use Apache::ParseLog;                                 # CPAN-Modul

$mytransferlog = "/usr/local/apache/logs/access_log"; # Einstellen!

# Wir parsen den Apache-Transferlog auf der Suche nach Hits
$apalog = new Apache::ParseLog();
$apalog = $apalog->config(transferlog => $mytransferlog);

$trlog  = $apalog->getTransferLog();
%file   = $trlog->file();                     # Schluessel: Dateien
                                              # Werte     : Hit-Count

# Nun sortieren wir nach absteigenden numerischen Werten, dann
# nach aufsteigenden Dateinamen
foreach $fn (sort { $file{$b} <=> $file{$a}
                                or
                            $a cmp $b } keys %file) {
    print "$file{$fn}\t$fn\n";
}
