#!/usr/local/bin/perl -w
# apache-mmap-reader.pl -- Zeigt lokale IPC mit Apache::Mmap.
#                          Liest aus einer mit mmap() in den
#                          Speicher abgebildeten Datei.

use Apache::Mmap qw(PROT_READ MAP_SHARED);  # CPAN-Modul
use Fcntl;

# Wir verwenden hier nur die TIESCALAR-Schnittstelle.
# Siehe 'man Apache::Mmap' fuer mmap() und munmap().

use constant MMAPFILE  => "/tmp/mmapped-file";
use constant MAXLENGTH => 70;
use constant OFFSET    => 0;

use constant UPDATETIME  => 4;    # So viele Sekunden schlafen
@SIG{qw(INT HUP TERM QUIT)} = ( sub { untie($mymmap); exit 0; } ) x 4;

# Zuerst oeffnen wir die Datei zum Lesen.
sysopen(FILE, MMAPFILE, O_RDONLY)
    or die "can't open MMAPFILE: $!\n";

tie $mymmap, 'Apache::Mmap', *FILE, MAXLENGTH,
    PROT_READ, MAP_SHARED, OFFSET
    or die "can't mmap to MMAPFILE: $!\n";

while (1) {
    $ttt = $mymmap;     # Datei lesen!
    printf("[%d upd.]: >%s<\n", UPDATETIME, $ttt);
    sleep(UPDATETIME);
}
