#!/usr/local/bin/perl
# bigfloat.pl -- Verwendung des Moduls Math::BigFloat

use Math::BigFloat;                # Standardmodul

# Erzeugen von Math::BigFloat-Objekten mit dem Konstruktor 'new':
my $pi = Math::BigFloat->new('3.14159265358979323846264338328');
my $e  = Math::BigFloat->new('2.71828182845904523536028747135');

# Die arithmetischen Operatoren sind ueberladen worden:
$pi_plus_e      = $pi + $e;
$e_minus_pi     = $e  - $pi;
$pi_mal_minus_e = $pi * -$e;
$pi_durch_e     = $pi / $e;
$wurzel_e       = $e->fsqrt();

# Die Ausgabe erfolgt in kanonischer Form:
print '$pi       == ', $pi, "\n";
print '$e        == ', $e,  "\n\n";

print '$pi + $e  == ', $pi_plus_e, "\n";
print '$e  - $pi == ', $e_minus_pi, "\n";
print '$pi * -$e == ', $pi_mal_minus_e, "\n";
print '$pi / $e  == ', $pi_durch_e, "\n";
print 'Wurzel $e == ', $wurzel_e, "\n\n";

# Siehe Dokumentation von Math::BigFloat zur Anzahl der Stellen.
# Math::BigFloat und native Zahlen koennen gemischt werden.
print '1 / 3     == ', Math::BigFloat->new('1.00000') / 3, "\n";

# Nicht-Zahlen (NaN) bei ungueltigen Operationen:
print 'fsqrt(-1) == ', Math::BigFloat->new('-1.0')->fsqrt(), "\n";
