#!/usr/local/bin/perl
# bigintcmp.pl -- Ueberladene Vergleichsoperatoren bei Math::BigInt
#                 ermoeglichen eine richtige (numerische) Sortierung.

use Math::BigInt;

# Bei neueren Math::BigInt Versionen (> Perl-5.6.0)
# sind keine Blanks mehr erlaubt.
# my $n1 = Math::BigInt->new('12345 67890 12345 67890');
# my $n2 = Math::BigInt->new('98765 43210 98765');
# my $n3 = Math::BigInt->new('55555 55555 55555 55555');

my $n1 = Math::BigInt->new('12345678901234567890');
my $n2 = Math::BigInt->new('987654321098765');
my $n3 = Math::BigInt->new('55555555555555555555');

@biglist = ( $n1, $n2, $n3 );

# +12345678901234567890, +55555555555555555555, +987654321098765
print join(", ", sort @biglist), "\n";
