#!/usr/local/bin/perl -w
# cgi-s-hidden.pl -- Zustandserhaltung mit Hidden-Feldern.

use strict;
use CGI qw(:standard);

my $state      = retrieve_state();
my $nextstate  = compute_next_state($state);
my $saveaction = save_state($nextstate, "Click me for next state");

# Tue etwas abhaengig von $state:
print header,
    start_html('State with Hidden Fields'),
    "Current state: ", $state, p,
    start_form(),
      $saveaction,
      submit({-value => "Click me for next state"}),
    end_form(),
    end_html;

use constant INITSTATE => 1;
use constant STATENAME => 'mystate';
sub retrieve_state {
    my $state = param(STATENAME) || INITSTATE;
    return $state;
}

sub compute_next_state {
    my $current_state = shift;
    return $current_state + 1;
}

sub save_state {
    my $newstate = shift;
    my $send_me_back = hidden({-name     => STATENAME,
			       -value    => $newstate,
			       -override => 1});
    return $send_me_back;
}
