#!/usr/local/bin/perl -w
# cgi-s-query.pl -- Zustandserhaltung mit QUERY_STRING.

use strict;
use CGI qw(:standard);

my $state      = retrieve_state();
my $nextstate  = compute_next_state($state);
my $saveaction = save_state($nextstate, "Click me for next state");

# Tue etwas abhaengig von $state:
print header,
    start_html('State with QUERY_STRING'),
    "Current state: ", $state, p,
    $saveaction,
    end_html;

use constant INITSTATE => 1;
sub retrieve_state {
    my $state = param('state') || INITSTATE;
    $state =~ s,^/,,;
    return $state;
}

sub compute_next_state {
    my $current_state = shift;
    return $current_state + 1;
}

sub save_state {
    my $newstate = shift;
    my $info     = shift;
    my $send_me_back = a({-href => url() . "?state=$newstate"}, $info);
    return $send_me_back;
}
