#!/usr/local/bin/perl -w
# closure1.pl -- Das Grundprinzip der Closure

sub make_log {
    my $base = shift;
    return sub { return log(shift())/log($base); };
}

$loge  = make_log(exp(1));  # Neue Funktion: Natuerlicher Logarithmus
$log2  = make_log(2);       # Neue Funktion: Logarithmus zur Basis 2
$log10 = make_log(10);      # Neue Funktion: Logarithmus zur Basis 10

print "log2(1024)  = ", &$log2(1024),  "\n";
print "log10(1000) = ", &$log10(1000), "\n";
print "loge(100)   = ", &$loge(1000),  "\n";
