#!/usr/local/bin/perl -w
# closure4.pl -- Einfacher Puffer. Closure mit gemeinsamen Daten

sub make_buffer {
    my @buf;                      # Gemeinsamer Puffer

    my $insert = sub { return push(@buf, shift()); };
    my $remove = sub { return shift(@buf); };
    my $first  = sub { return $buf[0]; };
    my $last   = sub { return $buf[$#buf]; };
    my $all    = sub { return @buf; };

    return ($insert, $remove, $first, $last, $all);
}

# Erzeuge einen Puffer und Zugriffsmethoden
($i,$r,$f,$l,$a) = make_buffer();

# Arbeite mit diesem Puffer:
&$i("hello"); &$i("brave"); &$i("new"); &$i("world");
print join(" ", &$f(), &$l()), "\n";
&$r();
print join(" ", &$a()), "\n";
