#!/usr/local/bin/perl
# complex.pl -- Zeigt die Verwendung der Math::Complex-Zahlen.

use Math::Complex;                            # Standardmodul

# Wir erzeugen erst einige komplexe Zahlen:
$z1 = Math::Complex->make(3, 4);              # Kartesisch -> 3+4i
$z2 = -5.3 + 4.6*i;                           # Symbol i ist ueberladen
$z3 = Math::Complex->emake(2, pi/2);          # Polar -> 2i

# Die Zahlen werden richtig angezeigt:
print join("\n", $z1, $z2, $z3), "\n";

# Einige einfache arithmetische und mathematische Operationen:
print '$z1 / $z2  = ',   $z1/$z2,      "\n";  # Komplexe Division
print 'Re($z3)    = ',   $z3->Re(),    "\n";  # Realteil.
print 'Im($z3)    = ',   $z3->Im(),    "\n";  # Imaginaerteil.

print 'sin($z3)   = ',   sin($z3),     "\n";  # Sinus
print 'acos($z2)  = ',   acos($z2),    "\n";  # acos(), komplex
