#!/usr/local/bin/perl -w
# data-dumper-purity.pl -- Zirkulaere Referenzen mit Data::Dumper
#                  Aufruf ohne Argumente: Keine Purity => falsch!
#                  Aufruf mit Argumenten: Mit Purity   => richtig!

use Data::Dumper;                             # Standardmodul

# Eine komplexe, zirkulaere Datenstruktur
$f = { Cite    => [ qw(a circular list) ],
       Element => 'a rose is' };
$f->{'Next'} = \$f;    # a rose is a rose is a rose is a ...

{
    # Stringifizieren, mit oder ohne Purity:
    local $Data::Dumper::Purity = 1 if defined $ARGV[0];
    $str = Data::Dumper->Dump([$f], [qw($new_f)]);
    print "String:\n", "$str\n";

}
