#!/usr/local/bin/perl -w
# db-listdb.pl -- Zeigt alle vorhandenen MySQL-Datenbanken an.

use DBI;

sub list_db_localhost {
    # Liefert eine Liste gerade installierter Datenbanken auf
    # dem lokalen Rechner (localhost) zurueck.
    # Verwendung: @db = list_db_localhost();
    return DBI->data_sources("mysql");
}

sub list_db_remote {
    # Liefert eine Liste von Datenbanken auf einem MySQL-Host
    # mit Namen 'host' und Port 'port' zurueck.
    # Verwendung: @db = list_db_remote();
    #             @db = list_db_remote( host => $host );
    #             @db = list_db_remote( host => $host, port => $port );
    my %p = ( host => 'localhost',
              port => '3306',
              @_ );
    my $drh = DBI->install_driver("mysql");
    return $drh->func($p{'host'}, $p{'port'}, "_ListDBs");
}

print "databases on localhost:\n";
print map { "\t" . "$_\n" } list_db_localhost();

print "remote:port> "; chomp($rp = <STDIN>);
($host, $port) = split(/:/, $rp);
print "databases on $rp:\n";
print map { "\t" . "$_\n" } list_db_remote(host => $host, port => $port);
