#!/usr/local/bin/perl -w
# db-listfld.pl -- Liste von Feldnamen einer bestimmten Tabelle.

use DBI;

sub list_fields {
    # Liefert eine Liste von Feldnamen der Tabelle $table
    # aus der geoeffneten Datenbank mit dem Handle $dbh zurueck.
    # Verwendung: @fields = list_fields($dbh, $table);
    my $dbh   = shift;
    my $table = shift;
    my @allfields;

    my $sth = $dbh->prepare("LISTFIELDS $table");
    $sth->execute();
    if ($DBI::err) {
        print STDERR "list_fields(): $DBI::err ... $DBI::errstr\n";
        return;
    }
    @allfields = @{$sth->{NAME}};
    $sth->finish();

    return @allfields;
}

# Eine Verbindung zu einer Datenbank oeffnen.
# Wir koennten auch open_dbase() aus db-listtbl.pl verwenden.
$dbh = DBI->connect("DBI:mysql:database=mydbase",
		    "manager", "mgrpass");
print STDERR "Error connecting to mydbase: $DBI::errstr\n"
        unless $dbh;

# Nun geben wir alle Feldnamen der Tabelle 'kunden' aus:
print "Fields of kunden:\n";
print map { "\t" . "$_\n" } list_fields($dbh, 'kunden');
$dbh->disconnect();
