#!/usr/local/bin/perl -w
# db-prepare.pl -- Zeigt die Verwendung von SELECT in Perl.

use DBI;

# Einloggen:
$dbh = DBI->connect("DBI:mysql:mydbase", "manager", "mgrpass");
die "Error: $DBI::errstr\n" unless $dbh;

# Eine SELECT-Abfrage:
$sql = <<EOSELECT;
SELECT name, vorname, ort
       FROM  kunden, plzorte
       WHERE kunden.plz >= 40000
         AND kunden.plz = plzorte.plz
       ORDER BY name
EOSELECT

# Abfrage zum Datenbankserver senden:
$sth = $dbh->prepare($sql);
die "Error: $DBI::errstr\n" if $DBI::err;

# Abfrage ausfuehren:
$sth->execute();
die "Error: $DBI::errstr\n" if $DBI::err;

# Ergebnisse abholen:
while (@fields = $sth->fetchrow_array()) {
    # Aktuellen Ergebnisdatensatz bearbeiten.
    print join("\t", @fields), "\n";
}

# Abfrage abschliessen:
$sth->finish();

# Das war's, Leute!
$dbh->disconnect();
