#!/usr/local/bin/perl -w
# errno.pl -- Reservierte Variablen fuer Fehlercodes

use vars qw (*IFILE *OFILE $output);

# Folgende Datei existiert nicht:
open (IFILE, "< /no/such/file")
    or warn "Error: $!\n";

# Von einem nicht-root User,
# kann /etc/passwd nicht beschrieben werden:
open (OFILE, ">> /etc/passwd")
    or warn "Error: $!\n";

# $! ist sogar schreibbar:
$! = 16;    # EBUSY: Mount device Busy
print "Error: $!\n";

# Fehler bei der Ausfuehrung eines Kindprozesses in Backticks:
$output = `/no/such/file 2>/dev/null`;
print "Child Error: $?\n";

# Fehler bei eval():
$code = '$erg = 5/0';
eval $code or print "Eval Error: $@";
print "Still living!\n";
