#!/usr/local/bin/perl
# form-demo.pl -- Report-Generator mit Formaten und write().
#                 Zeigt die Passwortdatei tabellarisch an.

$host = `hostname`; chomp $host;
open (PASSWD, '< /etc/passwd')
             or die "can't open password file: $!\n";
while (<PASSWD>) {
    chomp;
    ($name, $gcos, $shell) = (split(/:/))[0,4,6];

    write;        # Einen Datensatz formatiert ausgeben.
                  # Bei der ersten Seite und bei jedem
                  # Seitenwechsel wird ein Top-of-page-Format
                  # zusaetzlich am Anfang der Seite ausgegeben.
}
close (PASSWD);

# Das Top-of-page-Format wird am Anfang jeder Seite
#   automatisch angezeigt.
format STDOUT_TOP =
-------------------------------------------------------------
     Eingetragene User auf @<<<<<<<<<<<<<<<<<<<<    Seite @>>
                $host,                               $%
-------------------------------------------------------------
Login-Name   Echter Name               Login Shell
----------   ----------------------    ----------------------
.

# Das Format eines einzelnen Datensatzes, der mit write()
#   ausgegeben wird.
format STDOUT =
@<<<<<<<<<   @<<<<<<<<<<<<<<<<<<<<<    @<<<<<<<<<<<<<<<<<<<<<
$name, $gcos, $shell
.
