#!/usr/local/bin/perl -w
# hashbind1.pl -- Persistente Hashes mit Hilfe der tie()-Funktion
#                 erzeugen.

use SDBM_File;                                 # Standardmodul
use Fcntl;                                     # O_CREAT, O_RDONLY...

tie (%hash, 'SDBM_File', '/tmp/mytempfile', O_RDWR|O_CREAT, 0640)
    or die "can't tie %hash to SDBM_File: $!\n";

print "Actual contents:\n",
    join("\n", map { "($_ => $hash{$_})" } sort keys %hash), "\n";

print "A key please? "; $key = <STDIN>; chomp $key;
print "and a value ? "; $val = <STDIN>; chomp $val;
$hash{$key} = $val;              # Hier wird die Datei ergaenzt.

untie(%hash);                    # Ab hier wirken sich Aenderungen
                                 # nicht mehr auf die SDBM-Datei aus.
