#!/usr/local/bin/perl -w
# inheriting-attributes.pl -- Vererbung von Datenelementen.

package Base;
sub new {
    my ($cn, $self) = (shift, {});
    $self->{'name'} = shift;
    return bless($self, $cn);
}

sub stringify {
    my $self = shift;
    return join(' ', ref($self),
                     map { "$_/$self->{$_}" } sort keys %{ $self });
}

package Derived;
use vars qw( @ISA );
@ISA = qw( Base );

sub new {
    my $cn = shift;
    my $self  = $cn->SUPER::new( shift );
    $self->{'phone'} = shift;
    return $self;                 # bless() wurde schon aufgerufen.
}

package main;
my $obj = Derived->new('mary', '555-1234');
print $obj->{'name'}, " has phone ", $obj->{'phone'}, "\n";
print $obj->stringify(), "\n";
