#!/usr/local/bin/perl -w
# ipcmsg1.pl -- Erzeugt eine Message-Queue

use IPC::SysV qw(IPC_CREAT S_IRWXU ftok);
use IPC::Msg;

# Die folgenden Konstanten kennzeichnen die Message-Queue im System.
# RENDEZVOUS muss der Name einer _existierenden_ Datei sein!
# Nur die unteren 8 Bits von RVID sind wichtig und muessen !=0 sein!
# ftok(RENDEZVOUS, RVID) erzeugt einen immer identischen Schluessel,
# so lange die Datei RENDEZVOUS nicht neu angelegt wurde.
use constant RENDEZVOUS => "/etc/group";
use constant RVID       => 121;

# Erzeugt eine Message-Queue mit dem Namen RENDEZVOUS,
# wenn sie noch nicht vorher existiert hat.
use vars qw($msg);
$msg = new IPC::Msg(ftok(RENDEZVOUS, RVID), S_IRWXU | IPC_CREAT);
