#!/usr/local/bin/perl -w
# ipcmsg3.pl -- Liest einige Eintraege der Message-Queue

use IPC::SysV qw(ftok);
use IPC::Msg;
use constant RENDEZVOUS => "/etc/group";
use constant RVID       => 121;
use constant BUFLEN     => 256;      # Max. Groesse des Puffers

# Stelle Verbindung zur Message-Queue her.
$msg = new IPC::Msg(ftok(RENDEZVOUS, RVID), 0);

# Besorge das erste Element. The-Borg: "Prioritaet ist irrelevant!"
$prio = 0;
$prio = $msg->rcv($buf,BUFLEN,$prio,0)
                or warn "msgrcv(): first element: $!\n";
proceed($buf,$prio);

# Besorge das erste Element mit Prioritaet 5
$prio = 5;
$prio = $msg->rcv($buf,BUFLEN,$prio,0)
                or warn "msgrcv(): elem w. prio 5: $!\n";
proceed($buf,$prio);

# Besorge das erste Element mit Prioritaet >= 2
$prio = -2;
$prio = $msg->rcv($buf,BUFLEN,$prio,0)
                or warn "msgrcv(): elem w. less eq. prio 2: $!\n";
proceed($buf,$prio);

# Nachricht zusammen mit Prioritaet anzeigen.
sub proceed {
    my ($buf,$prio) = @_;
    print "Found: ($buf, $prio)\n";
}
