#!/usr/local/bin/perl -w
# ipcp1.pl -- Erzeugt ein Shared-Memory-Segment

use IPC::SysV qw(ftok IPC_CREAT S_IRWXU);
use constant RENDEZVOUS => "/etc/passwd";
use constant RVID       => 121;
use constant SIZE       => 2000;

# Erzeuge ein Shared-Memory-Segment.
$id = shmget(ftok(RENDEZVOUS, RVID), SIZE, S_IRWXU | IPC_CREAT)
    or die "can't create shared memory segment: $!\n";

# Nachrichten, die im Shared-Memory-Segment landen sollen:
$message1 = "Wizard's Password: ";
$message2 = "xyzzy";

# Schreibe beide Nachrichten in das Shared-Memory-Segment.
shmwrite($id, $message1,  0, 60) || die "$!\n";
shmwrite($id, $message2, 61, 60) || die "$!\n";

printf "Shared Memory 120 Bytes on key: %x\n", ftok(RENDEZVOUS, RVID);
