#!/usr/local/bin/perl -w
# ipcp2.pl -- liest und schreibt in einem SHM-Segment

use IPC::SysV qw(ftok);
use constant RENDEZVOUS => "/etc/passwd";
use constant RVID       => 121;
use constant SIZE       => 2000;

# Stelle Verbindung (attach) zum von ipcp1.pl erzeugten
# Shared-Memory-Segment her.
# Hinweis: Wir erzeugen das Segment NICHT neu!
$id = shmget(ftok(RENDEZVOUS, RVID), SIZE, 0) or
    die "can't attach to shared memory segment: $!\n";

# Lese SHM-Inhalte in lokale Variablen ein
$message1 = $message2 = '';
shmread($id, $message1,  0, 60) || die "$!\n";
shmread($id, $message2, 61, 60) || die "$!\n";

$result = $message1 . $message2;      # Zusammenfuegen

# Ergebnis ab Offset 121 im SHM-Segment ablegen
shmwrite($id, $result, 121, 120) || die "$!\n";

printf "Shared Memory 120 Bytes on key: %x\n", ftok(RENDEZVOUS, RVID);
