#!/usr/local/bin/perl -w
# ipcp3.pl -- Liest das SHM-Segment aus und gibt es dann frei.

use IPC::SysV qw(ftok IPC_RMID);
use constant RENDEZVOUS => "/etc/passwd";
use constant RVID       => 121;
use constant SIZE       => 2000;

# Stelle Verbindung zum existierenden SHM-Segment her.
$id = shmget(ftok(RENDEZVOUS, RVID), SIZE, 0) or
    die "can't attach to shared memory segment: $!\n";

# SHM-Segment in lokale Variablen auslesen...
$message1 = $message2 = $message3 = '';
shmread($id, $message1,   0,  60) || die "$!\n";
shmread($id, $message2,  61,  60) || die "$!\n";
shmread($id, $message3, 121, 120) || die "$!\n";

# ... und ausgeben.
print "M1:$message1\n";
print "M2:$message2\n";
print "M3:$message3\n";

# SHM-Segment freigeben (d.h. zerstoeren).
shmctl($id, IPC_RMID, 0) || die "$!\n";

printf "Killed Shared Memory on key: %x\n", ftok(RENDEZVOUS, RVID);
