#!/usr/local/bin/perl -w
# lwp-uacredentials.pl -- Basic Authentication mit LWP::UserAgent

use LWP::UserAgent;

# Die folgende Default-URL erfordert eine Authentifikation.
$url = $ARGV[0] || "http://localhost/cgi-bin-secure/cgi-printenv.pl";

$ua  = new LWP::UserAgent;
$req = new HTTP::Request 'GET' => "$url";

# Auf alle Faelle geben wir unsere Daten an.
# Diese werden nur benutzt, wenn der Server dies wuenscht.
$req->authorization_basic('testuser1' => 'testpass1');

# Die Anforderung wird wie gewoehnlich gestellt.
# Bei Bedarf wird auf das Challenge durch das Senden
# von User- und Passwortdaten geantwortet.
$res = $ua->request($req);

$result = $res->is_success() ? 
    $res->content() :
    "Error: " . $res->code() . " " . $res->message();

print "$result\n";
