#!/usr/local/bin/perl -w
# lwp-uasimple.pl -- Informationen anfordern mit dem UserAgent

use LWP::UserAgent;

# Die gewuenschte URL:
$url = $ARGV[0] || "http://www.perl.com/CPAN/SITES";

# Ein UserAgent-Objekt, das die Anfrage anstossen wird.
$ua  = new LWP::UserAgent;

# Ein Anfrageobjekt, das genau das enthaelt, was wir wollen.
$req = new HTTP::Request 'GET' => "$url";

# Die Anfrage wird hiermit angestossen.
# Ergebnis ist ein Antwortobjekt.
$res = $ua->request($req);

# Was ist? Hat die Anfrage geklappt?
$result = $res->is_success() ? 
    # Ja, wir wollen die Seite sehen.
    $res->content() :
    # Nein, HTTP-Fehlercode und Fehlerursache ausgeben.
    "Error: " . $res->code() . " " . $res->message();

print "$result\n";
