#!/usr/local/bin/perl -w
# lwp-uatimeout.pl -- Seite mit Timeout anfordern

use LWP::UserAgent;
use constant TTW => 3;    # Wartezeit in Sekunden

$url = $ARGV[0] || "http://busyserver.somewhere.com/";
$tts = $ARGV[1] || TTW;   # Wartezeit von Kommandozeile lesen

$ua  = new LWP::UserAgent;

# Wir stellen hiermit die Wartezeit in Sekunden ein.
$ua->timeout($tts);

$req = new HTTP::Request 'GET' => "$url";
$res = $ua->request($req);

$result = $res->is_success() ? 
    $res->content() :
    "Error: " . $res->code() . " " . $res->message();

print "$result\n";
