#!/usr/local/bin/perl -w
# mailthreads.pl -- Zeigt Subjects nach Themen sortiert an.

while (<>) {
    chomp;                           # Newline-Zeichen entfernen.
    next if not /^Subject:\s+(.*)/;  # Irrelevante Zeilen
                                     # ueberspringen.

    $subject = $1;                 # Zeile nach 'Subject: '
    $subject =~ s/^(Re:\s+)+//;    # Entferne fuehrende Replies
    $subject =~ s/(.*)/\L$1\E/;    # Konvertiere alles in
                                   # Kleinbuchstaben.

    ++$THREADS{$subject};          # Noch ein Thema?
}

# Themen nach absteigender Haeufigkeit sortiert anzeigen:
foreach my $thread (sort { $THREADS{$b} <=> $THREADS{$a} } 
                         keys %THREADS) {
    print "(" . $THREADS{$thread} . ")\t" . $thread . "\n";
}
