/* matrix.cc -- Matrix-Beispiel in C++: Variable Zeilengroessen */
/*              gcc -Wall -o matrix matrix.cc -lstdc++ */

#include <stdlib.h>
#include <errno.h>
#include <iostream.h>

const int MAXROW=3;
const int MAXCOL=3;

void myerror(const char *msg) { cerr << msg << endl; exit(1); }

int main(void) {
  double **matrix;

  /* Platz fuer MAXROW Zeilen schaffen */
  matrix = new double*[MAXROW];
  if (!matrix)
    myerror("out of memory!");

  for (int i=0; i<MAXROW; i++) {
    /* Platz fuer MAXCOL Spalten schaffen */
    double *row = new double[MAXCOL];
    if (!row)
      myerror("out of memory");

    /* Zeilen fuellen */
    for (int j=0; j<MAXCOL; j++)
      row[j] = i*j;       /* Irgendeinen Wert */

    /* Zeiger auf diese Zeile speichern */
    matrix[i] = row;      /* Zeile speichern */
  }

  /* Alles ausgeben bzw. damit rechnen */
  for (int i=0; i<MAXROW; i++) {
    for (int j=0; j<MAXCOL; j++)
      cout << matrix[i][j] << "\t";
    cout << "\n";
  }

  /* Alle Zeilen wieder freigeben, dann das Zeilenarray freigeben */
  /* [Optional, da am Ende des Programms!] */
  for (int i=0; i<MAXROW; i++)
    delete[] matrix[i];
  delete[] matrix;

  return 0;     /* Das war's */
}
