#!/usr/local/bin/perl -w
# obj-closures.pl -- Objekte mit Closures

sub new {
    my $theName  = shift;         # my wichtig!
    my $thePhone = shift;         # my wichtig!
    my $objptr = {
	get_name  => sub { return $theName;   },
	set_name  => sub { $theName = shift;  },
        get_phone => sub { return $thePhone;  },
        set_phone => sub { $thePhone = shift; },
        print_it  => sub { return "Name: $theName, Phone: $thePhone"; }
    };
    return $objptr;
}

$myobj1 = new 'Smith', '555-2321';
$myobj2 = new 'Jones', '555-1263';

print $myobj1->{'get_name'}->(), "\n";

$myobj2->{'set_phone'}->('555-9999');
print $myobj2->{'print_it'}->(), "\n";
