#!/usr/local/bin/perl -w
# opener.pl -- Wrapper um die open()-Funktion, der eine Referenz auf
#              ein geoeffnetes Filehandle zurueckliefert.

use Symbol;                       # Standardmodul: wg. gensym()
use strict 'refs';

sub Open {
  my $fname  = shift;             # Name der zu oeffnenden Datei
  my $anonfh = gensym();          # Referenz auf anonymes Filehandle
  open($anonfh, $fname) 
           or die "can't open $fname: $!\n";

  return $anonfh;                 # die Referenz zurueckliefern
}

# Eine moegliche Verwendung:
my $fh = Open("< /etc/group");
while (<$fh>) { print; }
close(*{$fh});
