#!/usr/local/bin/perl -w
# quickloops.pl -- Zeigt Beispiele von Schleifen in Perl.

# Die foreach-Schleife arbeitet die Elemente eines Arrays ab:
foreach my $file (sort </usr/include/*.h>) {
    print "$file\t", -s $file, "\n"       # Name und Groesse
        if -s $file > 50*1024;            # von Dateien > 50 Kbyte.
}

# Die klassische for-Schleife:
for ($i=5; $i>=0; --$i) { print $i, "..."; }
print "BOOM!\n";               # 5...4...3...2...1...0...BOOM!

# while-Schleifen:
($var, $i) = ('ok', 3);               # Parallele Zuweisung.
while ($var ne 'finished') {
    $var = 'finished' if $i-- == 0;
}

# do ... while-Schleifen:
($var, $i) = ('finished', 3);
do {
    $var = 'ok'; print "until loop entered\n";  # erscheint viermal.
    $var = 'finished' if $i-- == 0;
} while ($var ne 'finished');
