#!/usr/local/bin/perl -w
# quickoomath.pl -- Zeigt die OO-Schnittstelle von Math::BigInt.

use Math::BigInt;          # laedt das Modul Math::BigInt

# Wir erzeugen (instanziieren) ein neues Objekt der Klasse
# Math::BigInt mit Hilfe des new-Konstruktors:
$i = Math::BigInt->new("265252859812191058636308480000000");

# Aufruf von Methoden des Objekts $i bei gleichzeitiger
# Instanziierung von temporaeren Objekten, die als
# Argumente verwendet werden:
$gcd           = $i->bgcd(Math::BigInt->new("34342"));
($quot, $rema) = $i->bdiv(Math::BigInt->new("10000000"));

# Auch die Ausgabe eines Math::BigInt-Objekts ruft intern
# eine Anzeige-Methode auf.
print "The gcd is $gcd\n";  # The gcd is +154
print "Quotient : $quot\n"; # Quotient : +26525285981219105863630848
print "Remainder: $rema\n"; # Remainder: +0
