#!/usr/local/bin/perl -w
# regexp-o.pl -- Zeigt den Vorteil von m//o gegenueber m//

use Time::HiRes qw(gettimeofday tv_interval); # CPAN-Modul.
use vars qw($count1 $count2);

my $words = "/usr/share/lib/dict/words";      # Evtl. anpassen!

open(DICT, $words) or die "can't open $words: $!\n";
chomp(@words = <DICT>);
close DICT;

print "Pattern? "; chomp($pat = <STDIN>);

# Wir suchen einmal mit m//, dann mit m//o und vergleichen
# die Ausfuehrungszeiten:

# Suche ohne Optimierung:
$tstart = [gettimeofday];
foreach $word (@words) {
    $count1++ if $word =~ /$pat/;  # Ohne /o
}
$time1 = tv_interval($tstart, [gettimeofday]);

# Suche mit Optimierung:
$tstart = [gettimeofday];
foreach $word (@words) {
    $count2++ if $word =~ /$pat/o; # Mit /o
}
$time2 = tv_interval($tstart, [gettimeofday]);

print "Ohne Optimierung: $time1\n";
print "Mit  Optimierung: $time2\n";
