#!/usr/local/bin/perl -w
# spell-cached.pl -- Rechtschreibpruefung mit gecachtem
#                    Hash-Woerterbuch.

# Ort des Woerterbuchs. Ein Wort pro Zeile.
$dict   = '/usr/share/dict/words';

# Ort der DBM-Dateien
$dbfile = '/var/local/words';     # Gecachte richtige Woerter
$wfile  = '/tmp/wrongs';          # Gecachte falsche Woerter

# Liste der zu ueberpruefenden Woerter.
# Sie wuerde normalerweise aus einer Parsing-Funktion kommen.
@mywords = qw ( this is okay but nottt thhat right);

use DB_File;
tie %words, 'DB_File', $dbfile, O_CREAT|O_RDWR, 0644
    or die "can't tie to $dbfile: $!\n";
tie %wrongs, 'DB_File', $wfile, O_CREAT|O_RDWR, 0644
    or die "can't tie wrongs: $!\n";

WORDS: foreach $word (@mywords) {
    next if exists $words{$word};     # Gecacht, alles klar!
    if (exists $wrongs{$word}) {      # Als falsch gecacht!
	print "Misspelled: $word\n";
	next;
    }

    open (DICT, "< $dict") or die "can't open $dict: $!\n";
    while (defined ($dword = <DICT>)) {
	chomp $dword;
	if ($dword eq $word) {
	    $words{$word} = "";        # Cachen, ist okay
	    close DICT;
	    next WORDS;
	}
    }
    close DICT;
    $wrongs{$word} = "";               # Cachen, falsche Woerter
    print "Misspelled: $word\n";
}

untie %wrongs;
untie %words;
