#!/usr/local/bin/perl -w
# statme.pl -- Zeigt alle stat()-Informationen einer Dateiliste an

foreach $file (@ARGV) {
    unless (($dev, $ino, $mode, $nlink, $uid, $gid,
             $rdev, $size, $atime, $mtime, $ctime,
	     $blksize, $blocks) = stat($file)) {
        warn "can't stat() $file: $!\n";
    } else {
        $octmode        = sprintf("%o", $mode);
        $physsize       = $blksize * $blocks;
        $at             = scalar localtime($atime);
        $mt             = scalar localtime($mtime);
        $ct             = scalar localtime($ctime);

        print <<"...";
File            : $file

Device          : ($dev, $rdev) Inode: $ino
Mode            : 0$octmode
Number of Links : $nlink
Owner           : ($uid, $gid)
Logical Size    : $size Bytes
Physical Size   : $blocks Blocks ($blksize Bytes/Block) == $physsize
Access Time     : $at
Mod.   Time     : $mt
Inode  Time     : $ct
...
    }
}
