#!/usr/local/bin/perl -w
# stringparts4.pl -- Zerlege den String in Chunks konstanter Laenge,
#                    auch wenn die Anzahl der Chunks im voraus
#                    nicht bekannt ist.

print "Aus wie vielen Chunks sollte die Eingabe bestehen? ";
$string  = "chunk" x <> . "chu"; # Erfrage die Anzahl Chunks dynamisch
                                 # und erzeuge eine Test-Eingabe.
                                 # Unvollstaendiger Chunk am Ende.

$chsize  = length "chunk";       # Groesse eines einzelnen Chunks

@chunks  = unpack("a$chsize" x (length($string)/$chsize) . " a*",
                  $string);

$nchunks = @chunks;              # Liefert Anzahl der Chunks
print "Wir haben $nchunks Chunks!\n";
print "Erster     Chunk: >", $chunks[0],          "<\n";
print "Vorletzter Chunk: >", $chunks[$#chunks-1], "<\n";
print "Letzter    Chunk: >", $chunks[$#chunks],   "<\n";

# Ausgabe bei Eingabe von 7:
# 
# Aus wie vielen Chunks sollte die Eingabe bestehen? 7
# Wir haben 8 Chunks!
# Erster     Chunk: >chunk<
# Vorletzter Chunk: >chunk<
# Letzter    Chunk: >chu<
