#!/usr/local/bin/perl -w
# tcp-server-st.pl -- Ein Single-threaded-TCP-Server

use IO::Socket;

use constant MYPORT => 7123;
$sock = new IO::Socket::INET(LocalPort => MYPORT,
		             Reuse     => 1,
		             Listen    => 5)
    or die "can't create local socket: $@\n";

print "Accepting connections on Port ", MYPORT, "...\n";
while ($client = $sock->accept()) {
    # Eine Verbindung ist eingetroffen.
    # Finden wir erst heraus, mit wem wir es zu tun haben.
    print "Accepted connection from ",
          $client->peerhost(), ":", $client->peerport(), "\n";

    # Wir reagieren wie ein ohce, das alles umdreht:
    while (<$client>) {
	chomp;
	print $client scalar(reverse($_)), "\n";
    }
}
