#!/usr/local/bin/perl -w
# tempfile-tmpnam.pl -- Temporaere Datei mit bekanntem Namen

use Fcntl;                          # wg. den O_*-Konstanten
use POSIX qw(tmpnam);               # Funktion tmpnam()

$ENV{'TMPDIR'} = '/var/tmp';        # Alternatives Temp-Verzeichnis

# Erzeugen wir die temporaere Datei:
do {
    $path = tmpnam();
} until sysopen(TMPFH, $path, O_RDWR | O_CREAT | O_EXCL, 0700);
select((select(TMPFH),$|=1)[0]);    # Pufferung aus!
print STDERR "Name of tempfile: $path\n" if defined $^W;

# Nun verwenden wir die Datei, z.B.:
print TMPFH "Never mount a scratch monkey\n"; # selbst beschreiben
system("cat", $path);                         # anderer liest.

END   { unlink($path) or die "can't unlink $path: $!\n"; }
