/* test5.c -- Funktion mit mehreren Argumenten und Rueckgabewerten */
/*            Mit embedmain.c zusammenlinken.                      */
/*            Mit c-test5.pl aufrufen.                             */

#include <EXTERN.h>
#include <perl.h>

#include <stdio.h>
#include <string.h>

#define NRSTRINGS 5
#define MYBUFSIZE 80

void doit(void) {
  dSP;

  char inputstring[MYBUFSIZE];
  char *reversed, *collected[NRSTRINGS];
  SV   *result;
  int  nvals, i;

  ENTER;
    SAVETMPS;
      PUSHMARK(SP);
        for(i=0; i<NRSTRINGS; i++) {
	  printf("Inputstring (%d): ", i);
	  fgets(inputstring, sizeof(inputstring)-1, stdin);
          inputstring[sizeof(inputstring)-1] = '\0';

          /* Ab auf den Argumentenstack! */
	  XPUSHs(sv_2mortal(newSVpv(inputstring, 0)));
	}
      PUTBACK;

      nvals = perl_call_pv("func1", G_ARRAY);
      SPAGAIN;

      /* Es sollten genauso viele Ergebnisse bereitstehen */
      if (nvals != NRSTRINGS)
	croak("This should not happen!\n");

      /* Die Ergebnisse in umgekehrter Reihenfolge vom Stack nehmen */
      /* Wir speichern Ergebnisstrings in einem C-Stack collected[] */
      for (i=NRSTRINGS-1; i>=0; i--) {
	result   = POPs;                 /* Das Ergebnis ist hier   */
	reversed = SvPV(result, PL_na);  /* PL_na oder int uulen    */
	collected[i] = reversed;         /* Und zwischenspeichern   */
      }

      /* Nun koennen wir die Ergebnisse in der richtigen Reihenfolge */
      /* wieder vom C-Stack collected[] nehmen. */
      for (i=0; i<NRSTRINGS; i++)
	printf("%s(%d) ", collected[i], i);
      printf("\n");
 
      PUTBACK;
    FREETMPS;
  LEAVE;
}
