#!/usr/local/bin/perl -w
# udp-tagclient.pl -- UDP-Client fragt nach einer Tagline.
#                     Mit udp-server.pl verwenden oder jedem
#                     UDP-Server, der auf leere Anforderungsdatagramme
#                     reagiert, und ein Antwortdatagramm senden.

use Socket;
use IO::Socket;                 # Standardmodul

# Wir erzeugen einen "unconnected" UDP-Socket:
$sock = new IO::Socket::INET(Proto => 'udp')
    or die "can't create UDP Socket: $!\n";

use constant MYTAGPORT => 5555;         # Muss wie im Server sein!
my $hostname = $ARGV[0];
my $port     = MYTAGPORT;
my $ipaddr   = gethostbyname($hostname);
my $remaddr  = sockaddr_in($port, $ipaddr);

# Wir senden dem Tagline-Server ein leeres Datagramm:
die "can't send to $hostname\n"
    unless defined $sock->send("", 0, $remaddr);

# Wir lesen ein Antwortdatagramm und geben dessen Inhalt aus.
use constant MAXLEN => 1024;
$sock->recv($answer, MAXLEN, 0) || die "can't recv(): $!\n";
print $answer;
