#!/usr/local/bin/perl -w
# usage.pl -- Zeigt Kommandozeilen-Parsing und eine usage()-Funktion

use Getopt::Std;
use vars qw ($opt_h $opt_c $opt_w);
$0 =~ s,.*/,,;                               # Pfadname entfernen
getopts("hwc:") or usage();

usage() if defined $opt_h;                   # -h-Flag aufgerufen
print "-w flag set\n" if defined $opt_w;     # -w-Flag gesetzt
print "-c flag: $opt_c\n" if defined $opt_c; # -c-Option gesetzt
print "Arguments: ", join(':', @ARGV), "\n"; # restliche Argumente

sub usage {
    print STDERR <<EOUSAGE;
usage: $0 [-h] [-w] [-c argument] arg1 [arg2 ...]

    -h             shows this help page
    -w             an on/off flag
    -c argument    specify an argument

    arg1 arg2...   some arguments

    This is just a dummy program.
EOUSAGE

    # Der folgende RCS/CVS-Versionsstring lautete vor seiner
    # Erweiterung:  'DollarIdDollar', wobei zu Dollar das
    # passende Zeichen eingesetzt werden muss.
    print STDERR "\n",
          '$Id: usage.pl,v 1.3 1999/08/17 17:15:58 farid Exp $',
          "\n";

    exit 1;                            # Ende mit Fehlercode
}
