#!/usr/local/bin/perl -w
# ux-client.pl -- Ein einfacher UNIX-Domain-Socket-Client.
#                 Mit ux-server.pl verwenden...

use IO::Socket;
use constant UXSOCKADDR => "/tmp/ux-sock";

$sock = IO::Socket::UNIX->new( Peer     => UXSOCKADDR,
                               Type     => SOCK_STREAM,
                               Timeout  => 15 )
    or die "can't connect to Unix Socket: $!\n";

chomp($greetings = <$sock>);
print "Server said: >$greetings<\n";

print "Input: ";
while(<>) {
    print $sock $_;
    chomp($reply = <$sock>);
    print "Reply: >$reply<\n";
    print "Input: ";
}
