#!/usr/local/bin/perl -w
# ux-dgram-server.pl -- Ein einfacher UNIX-Domain-Socket-Server.
#                       Datagrammversion.

use IO::Socket;
use constant UXSOCKADDR => "/tmp/ux-dsock";
use constant MAXLENGTH  => 256;

unlink(UXSOCKADDR);
$sock = IO::Socket::UNIX->new( Local  => UXSOCKADDR,
                               Type   => SOCK_DGRAM )
    or die "can't bind to Unix Socket: $!\n";

$nreplies = 0;
print "Ready for Datagrams...\n";
while (1) {
    $len = MAXLENGTH;
    $sock->recv($input, $len);
    $output = reverse $input;
    $sock->send($output, length($output));
    print "sending: $output\n";
    print "Reversed ", ++$nreplies, " datagrams sofar...\n";
}
