#!/usr/local/bin/perl -w
# ux-server.pl -- Ein einfacher UNIX-Domain-Socket-Server.

use IO::Socket;
use constant UXSOCKADDR => "/tmp/ux-sock";
use constant GREETINGS  => "This is ux-server, a reversing ohce!\n";

unlink(UXSOCKADDR);
$sock = IO::Socket::UNIX->new( Local  => UXSOCKADDR,
                               Type   => SOCK_STREAM,
                               Listen => 5)
    or die "can't bind to Unix Socket: $!\n";

print "Ready to accept connections!\n";
while ($conn = $sock->accept()) {
    print "Got new connection!\n";
    print $conn GREETINGS;
    while (defined ($from_client = <$conn>)) {
	chomp($from_client);
	print $conn scalar reverse($from_client), "\n";
    }
}
