#!/usr/local/bin/perl -w
# wfreq2.pl -- Ermittelt die Haeufigkeit aller Woerter
#              Liste nach fallender Haeufigkeit anzeigen

while (defined ($line = <>)) {
    chomp $line;                  # abschliessendes Newline entfernen
    @words = split(/\s/, $line);  # anhand Whitespaces aufsplitten

    foreach $word (@words) {
        $word =~ s/\W//g;         # alle Nicht-Wort-Zeichen loeschen
        next if $word eq '';      # Leere Woerter uninteressant
        $freq{lc($word)}++;       # Haeufigkeit, case-insensitive.
    }
}

# Liste nach fallender Haeufigkeit anzeigen
# Nachteil hier: Bei gleicher Haeufigkeit,
#                keine Sortierung nach $key
foreach $key (sort { $freq{$b} <=> $freq{$a} } keys %freq) {
    print "$key: $freq{$key}\n";
}
