#!/usr/local/bin/perl -w
# wfreq3.pl -- Ermittelt die Haeufigkeit aller Woerter
#              Liste nach fallender Haeufigkeit anzeigen
#              und alphabetisch aufsteigend bei gleicher Haeufigkeit

while (defined ($line = <>)) {
    chomp $line;                  # abschliessendes Newline entfernen
    @words = split(/\s/, $line);  # anhand Whitespaces aufsplitten

    foreach $word (@words) {
        $word =~ s/\W//g;         # alle Nicht-Wort-Zeichen loeschen
        next if $word eq '';      # Leere Woerter uninteressant
        $freq{lc($word)}++;       # Haeufigkeit, case-insensitive
    }
}

# Liste nach fallender Haeufigkeit anzeigen
foreach $key (sort { $freq{$b} <=> $freq{$a}
                               or
                            $a cmp $b        } keys %freq) {
    print "$key: $freq{$key}\n";
}
